public class ArrayUtil {

    /**
     * Reverses the order of the elements in double array <code>arr</code>.
     * 
     * @param arr The array to be transformed.
     * @return The array in reverse order.
     */
    public static double[] reverse(double[] arr) {
        double[] reply = new double[arr.length];
        for(int i = 0; i < reply.length; i++) {
            reply[reply.length - 1 - i] = arr[i];
        }
        return reply;
    }

    public static int[] subArray(int[] arr, int start, int length) {
        if(start < arr.length) {
            if(arr.length - start < length)
                length = arr.length - start;
            int[] reply = new int[length];
            for(int i = 0; i < length; i++) {
                try {
                    reply[i] = arr[i + start];
                } catch(ArrayIndexOutOfBoundsException e) {
                }
            }
            return reply;
        } else
            throw new ArrayIndexOutOfBoundsException(start + " is not a valid start index.");
    }

    public static double[] subArray(double[] arr, int start, int length) {
        if(start < arr.length) {
            if(arr.length - start < length)
                length = arr.length - start;
            double[] reply = new double[length];
            for(int i = 0; i < length; i++) {
                try {
                    reply[i] = arr[i + start];
                } catch(ArrayIndexOutOfBoundsException e) {
                }
            }
            return reply;
        } else
            throw new ArrayIndexOutOfBoundsException(start + " is not a valid start index.");
    }

    public static long[] subArray(long[] arr, int start, int length) {
        if(start < arr.length) {
            if(arr.length - start < length)
                length = arr.length - start;
            long[] reply = new long[length];
            for(int i = 0; i < length; i++) {
                try {
                    reply[i] = arr[i + start];
                } catch(ArrayIndexOutOfBoundsException e) {
                }
            }
            return reply;
        } else
            throw new ArrayIndexOutOfBoundsException(start + " is not a valid start index.");
    }
}


